import java.util.Arrays;
import java.util.Stack;

public class Main {
    public static void main(String[] args) {
        String[] expression = {"2", "3", "+", "4", "*"};
        evaluateRPN(expression);
    }

    public static void evaluateRPN(String[] tokens) {
        Stack<Integer> stack = new Stack<>();
        System.out.println("Je zasobnik prazdny? " + stack.empty());
        System.out.println("Vypocet RPN pre vyraz: " + Arrays.toString(tokens));

        for (String token : tokens) {
            if ("+-*/".contains(token)) {
                System.out.println("Vrchny prvok (peek): " + stack.peek());
                int b = stack.pop();
                System.out.println("Odstraneny pravy operand (pop): " + b);

                int a = stack.pop();
                System.out.println("Odstraneny lavy operand (pop): " + a);
                System.out.println("Operacia: " + token);
                switch (token) {
                    case "+" -> stack.push(a + b);
                    case "-" -> stack.push(a - b);
                    case "*" -> stack.push(a * b);
                    case "/" -> stack.push(a / b);
                }

                int topValue = stack.peek();
                System.out.println("Pridany vysledok (push): " + topValue);
            } else {
                stack.push(Integer.parseInt(token));
                System.out.println("Pridany prvok (push): " + token + " -> " + stack);
            }
        }

        System.out.println("Je zasobnik prazdny? " + stack.empty());
        System.out.println("Hladanie (vzdialenosti) prvku 10 (search): " + stack.search(10));
        System.out.println("Hladanie (vzdialenosti) prvku 20 (search): " + stack.search(20));
        System.out.println("Konecny vysledok (pop): " + stack.pop());
        System.out.println("Je zasobnik prazdny? " + stack.empty());
    }
}